! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!******************************************
! Test program for omdetect
!******************************************
!---02.11.2001 VNY more robust calculation of exp() was made in order to 
!              avoid underflow messages
program CreateTest

use dal
use cal
implicit none



write(*,*) "L14 running the routine CreateTestImage (200 x 200 pixels)"

    !***************************************
    ! Create an image for the imaging chain
    !**************************************
! Was 180
!     call CreateTestImage(500, 500, 600, "testimage1.fts", "testlist1.lis", "IMAGING")
  ! was 180 sources
    call CreateTestImage(200, 200, 80, "testimage1.fts", "testlist1.lis", "IMAGING")
!  call CreateTestImage(256, 256, 10, "testimage1.fts", "testlist1.lis", "IMAGING")


!   call CreateTestImage(1024, 1024, 150, "testimage1.fts", "testlist1.lis", "IMAGING")
   
!    call CreateTestImage(100, 100, 1, "testimage1.fts", "testlist1.lis", "IMAGING")
    
   


    !***************************************
    ! Create an image for the fast-imaging chain
    !**************************************
!    call CreateTestImage(24, 24, 2, "testimage2.fts", "testlist2.lis", "FAST")


end program createtest
!****************************************
! Subroutine CreateTestImage
!****************************************
Subroutine CreateTestImage(nx, ny, nSource, imageFileName, srcListFileName, dataMode)
use dal



    integer, intent(in) :: nx, ny, nSource
    character(*), intent(in) :: imageFileName, srcListFileName
    character(*), intent(in) :: dataMode
    real r1

    integer :: dims(2)
    integer :: i, j, k
!******************************************************
! FRac exrended was 0.02
!*****************************************************
!    real, parameter  :: fracExtend=0.01, fracPoint = (1. - fracExtend)

!   real, parameter  :: fracExtend=0.05, fracPoint = (1. - fracExtend)
 real, parameter  :: fracExtend=0.0, fracPoint = (1. - fracExtend)


    real, parameter :: exposure = 1000.0
    real :: r, delta, xDash, yDash, ex1, ex2, f, f1
    real :: background
    real :: flux(nSource)
    real :: sigX(nSource)
    real :: sigY(nSource)
    real :: sigX1(nSource)
    real :: sigY1(nSource)

    real :: sigXTimesSigY(nSource)
    real :: pa(nSource)
    real :: xSource(nSource)
    real :: ySource(nSource)
    real :: rSourceFlux(nSource)
    integer(int8) :: eSource(nSource)
    real, parameter :: pi = 3.141592654
    type(DataSetT) :: outSet
    type(ArrayT) :: outArray 
    real(single), pointer :: image(:,:)
    real :: minFlux, maxFlux
    real, parameter :: nSigma = 10
    real, parameter :: maxSig = 1., minSig=0.25
    real :: x, y
  
    real :: gasdev
    real :: meanval
    real :: fwhm_major, fwhm_minor, plateScale
    real :: dx, dxSquared

!
!-----------------------------------------------------------------
!
! AMK
!
    type(TableT) :: modesTableH                        ! Modes table dataset handle.
    type(ColumnT), dimension(5) :: modesColumnH        ! Modes column handle.
    integer(int32), dimension(:), pointer :: modeP! Mode pointer.
    integer(int32), dimension(:), pointer :: windowX0P           ! WindowX0 pointer.
    integer(int32), dimension(:), pointer :: windowY0P           ! WindowY0 pointer.
    integer(int32), dimension(:), pointer :: windowDXP           ! WindowDX pointer.
    integer(int32), dimension(:), pointer :: windowDYP           ! WindowDY pointer.
    integer(int32), dimension(1) :: columnDim                    ! Column dimension.
    
    type(ArrayT) :: qualArrayH                                        ! Quality Array handle.
    integer(int32), dimension(2) :: qualArrayDim                 ! Quality array dimension.

    !---VNY 2.11.2001
    integer(int8), pointer :: qualArrayImage(:,:)
!    real, pointer :: psfImage(:, :)
    
    integer(int32) :: i0, j0, il, iu, jl, ju
!    integer size;

!+++
!+++ Changes to make work the call to random_seed in 64 bit
!+++ (see below for cahnges to code)
!+++ EO, Dec. 10th, 2010
!+++ 
!+++ Lines starting with !--- have been commented in original code
!+++ 
!+++
    integer :: i_seed
    integer(int32), allocatable, dimension(:) :: seed


!---    integer, dimension(8) :: iseed
    
!---    iseed=5

!
!-----------------------------------------------------------------
!

!    call GetPSFImage(psfImage)
!    psfNx = size(psfImage, 1)
!    psfNy = size(psfImage, 2)
!    write(*, *) "size of psf image =", psfNx, psfNy
    dims(1) = nx
    dims(2) = ny

!    call random_seed()
!---    call random_seed(PUT=iseed)
!    write(*,*) "L30 size=", size


!+++
!+++ Changes to make work the call to random_seed 
!+++ 
!+++ See above for the definition of variables
!+++
!+++ EO, Dec. 10th, 2010
!+++

    call random_seed(size=i_seed)
    allocate(seed(1:i_seed))
    call random_seed(put=seed)
    deallocate(seed)



    outSet = dataSet(imageFileName, create)
    outArray = addArray(outSet, "PRIMARY", real32, dims)
    image => real32array2Data(outArray)


! Add a MODES extension, detailing the science window parameters.
!
     
    modesTableH = addTable(outset, "MODES", 1)
    columnDim(1) = 1

    modesColumnH(1) = addColumn(modesTableH, "MODE", Integer32, "none",  columnDim)
    modeP => int32Data(modesColumnH(1))
    modeP = 0

    modesColumnH(2) = addColumn(modesTableH, "WINDOWX0", Integer32, "pixels",  columnDim)
    windowX0P => int32Data(modesColumnH(2))
    windowX0P = 0

    modesColumnH(3) = addColumn(modesTableH, "WINDOWY0", Integer32, "pixels",  columnDim)
    windowY0P => int32Data(modesColumnH(3))
    windowY0P = 0

    modesColumnH(4) = addColumn(modesTableH, "WINDOWDX", Integer32, "pixels",  columnDim)
    windowDXP => int32Data(modesColumnH(4))
    windowDXP = 0

    modesColumnH(5) = addColumn(modesTableH, "WINDOWDY", Integer32, "pixels",  columnDim)
    windowDYP => int32Data(modesColumnH(5))
    windowDYP = 0

    ! Release handles on data.
    call release(modesColumnH(1))
    call release(modesColumnH(2))
    call release(modesColumnH(3))
    call release(modesColumnH(4))
    call release(modesColumnH(5))
    call release(modesTableH)

! Add the quality extension to the image file.

    qualArrayDim(1) = nx
    qualArrayDim(2) = ny

    qualArrayH = addArray(outset, "QUALITY", Integer8, qualArrayDim)
    qualArrayImage => int8array2Data(qualArrayH)
    qualArrayImage=0

! Release handles on data.
    call release(qualArrayH)
!
!------------------------------------------------------------------------
!
    image = 0.0

    !call random_number(background)
    background=0.6
    background = background * 100.0
    write(*, *) "L189 background =" , background

    minFlux = nSigma * sqrt(background)
    maxFlux = minFlux * 1000.0  ! Was 100
    write(*,*) "L197 minFlux=", minFlux, " maxFlux=", maxFlux

    call random_number(xSource)
    call random_number(ySource)
    xSource = 5.0 + xSource * real(nx - 5)
    ySource = 5.0 + ySource * real(ny - 5)

    
    if (nSource .eq. 1) then
        xSource(1) = nx / 2
        ySource(1) = ny / 2
    end if           

    do i = 1, nSource
        call random_number(r1)
        if (r1 > fracExtend) then
            call random_number(flux)
 
            flux = flux * (maxFlux - minFlux) + minFlux
 
            sigX(i) = 1.0   ! was 0.5
            sigY(i) = 1.0   ! was 0.5
            eSource(i) = 0
            pa = 0.0
        else
            call random_number(flux)
            flux = minFlux + (maxFlux - minFlux)
            call random_number(sigX(i))
            
            sigX(i) = 0.5 + 10.0 * sigX(i)
            call random_number(sigY(i))
            sigY(i) = (0.5 + sigY(i)) * sigX(i)  ! was 0.5
            eSource(i) = 1
            call random_number(pa)
            pa = pa * 2.0 * pi
  
        end if
        sigXTimesSigY = sigX(i) * sigY(i)
        sigX1(i) = 2.0 * sigX(i) ** 2
        sigY1(i) = 2.0 * sigY(i) ** 2
    end do

   rSourceFlux = 0.0  
   do k = 1, nSource
      !write(*, *) "Source no ", k, " x=", xSource(k), " y=", ySource(k), " flux=", flux(k)
      write(*, *) k, xSource(k), ySource(k), flux(k)

        i0 = xSource(k) - 0.5
        j0 = ySource(k) - 0.5

!        i0 = xSource(k) - 0.5
!        j0 = ySource(k) - 0.5

        f =  0.159154943 / sigXTimesSigY(k)

        if (eSource(k) .eq. 0) then

            il = max(0, i0 - 20)
            iu = min(i0 + 20, nx - 1)
  

            jl = max(0, j0 - 20)
            ju = min(j0 + 20, ny - 1)
        else
            il = max(0, i0 - 200)
            iu = min(i0 + 200, nx - 1)
  

            jl = max(0, j0 - 200)
            ju = min(j0 + 200, ny - 1)
      
        end if

        do i = il, iu
!            x = real(i) + 0.5
            x = real(i) + 1.0
            dx = x - xSource(k)
            dxSquared = dx * dx
            do j = jl, ju
!                y = real(j) + 0.5
                y = real(j) + 1.0
                r = sqrt(dxSquared + (y - ySource(k)) ** 2)
                if (r .lt. max(sigX(k), sigY(k)) * 10.0) then

                    delta = atan2(y - ySource(k), dx)

                    xDash = r * cos(delta - pa(k))
                    yDash = r * sin(delta - pa(k))

                    ex1 = -(xDash ** 2 / sigX1(k))

                    ex2 = -(yDash ** 2 / sigY1(k))


       
                    if((ex1+ex2) .gt. -10) then
                                     
                       f1 = f * flux(k) * exp(ex1 + ex2)
                    

                        rSourceFlux(k) = rSourceFlux(k) + f1
                        image(i, j) = image(i, j) + f1
                    end if
                end if
            end do        
        end do
!        write(*, *) "Source flux=", rSourceFlux(k), " flux constant=", flux(k)
    end do

    !**************************************************
    ! Add noise
    !**************************************************


    do i = 0, nx - 1
        do j = 0, ny - 1
            f = gasdev()
            meanval = image(i, j) + background
            image(i, j) = meanval + f * sqrt(meanval) ! gaussian deviate
        end do
    end do

!    call setAttribute(outSet, "EXPOSURE", exposure)
!    call setAttribute(outset, "BLANK", 999999.9)   ! Added by CB
!    call setAttribute(outSet, "BINAX1", 1)
!    call setAttribute(outSet, "BINAX2", 1)
!    call setAttribute(outSet, "BINBPE", .false.)
!    call setAttribute(outSet, "FILTER", "V")
!    call setAttribute(outSet, "DATAMODE", trim(dataMode))
!    call setAttribute(outSet, "FRAMTIME", 9.874)
!    call setAttribute(outSet, "DEADFRAC", 0.017622)

    call AddFitsAttributes(outSet, dataMode, "V")

    call release(outArray)
    call release(outSet)

    open(20, file = srcListFileName, status= "unknown", form="formatted")
   
    write(20, *) nSource, background
    plateScale = 0.476513  
    do i = 1, nSource
        fwhm_major = 2.354 * plateScale * max(sigX(i), sigY(i))
        fwhm_minor = 2.354 * plateScale * min(sigX(i), sigY(i))

 
        write(20,*) xSource(i), ySource(i), rSourceFlux(i)/exposure, &
        fwhm_major, fwhm_minor, pa(i), esource(i)
    end do
    
!    deallocate(psfImage)
    close(unit=20)

end subroutine CreateTestImage

real function gasdev() result(output)

  integer, save :: iset = 0
  real :: fac, rsq, v1, v2, ranNumber
  real, save :: gset

  if(iset .eq. 0)then
     loop1: do
!---Test VNY 2.11.2001
        ranNumber=0.0

        call random_number(ranNumber)
        v1 = 2.0 * ranNumber - 1.0

        call random_number(ranNumber)
        v2 = 2.0 * ranNumber - 1.0
        rsq = v1 ** 2 + v2 ** 2
        if(rsq .ge. 1.0 .or. rsq .lt. 1e-6) then
           continue
        else
           exit loop1
        endif
     end do loop1
     fac = sqrt(-2.0 * log(rsq) / rsq)
     gset = v1 * fac
     output = v2 * fac
     iset=1
  else
     output = gset
     iset = 0
  endif
  return
end function gasdev

!**************************************************************
!
!*************************************************************
subroutine AddFitsAttributes(outSet, dataMode, filter)
use cal
use dal
    type(DataSetT) :: outSet
    character(*), intent(in) :: dataMode
    character(*), intent(in) :: filter
    call setAttribute(outSet, "DATE-OBS", "2000-05-18T06:53:35.000")
    call setAttribute(outSet, "DATE-END", "2000-05-18T07:10:15.000")

     
    call setAttribute(outSet, "EXPOSURE", 1000.0)
    call setAttribute(outset, "BLANK", 999999.9)   ! Added by CB
    call setAttribute(outSet, "BINAX1", 1)   ! A binned image
    call setAttribute(outSet, "BINAX2", 1)   ! A binned image
    call setAttribute(outSet, "BINBPE", .false.)
    call setAttribute(outSet, "FILTER", filter)
    call setAttribute(outSet, "DATAMODE", trim(dataMode))
    call setAttribute(outSet, "FRAMTIME", 9.874)
    call setAttribute(outSet, "DEADFRAC", 0.017622)
    call setAttribute(outset, "RA_SCX",   180.0_double)
    call setAttribute(outset, "DEC_SCX",   45.0_double)
    call setAttribute(outset, "PA",   45.0_double)
    call setAttribute(outset, "EQUINOX",   2000.0)

end subroutine AddFitsAttributes














